#!/bin/bash
#!/bin/bash
#This script is part of pinlabeler, by Peter Storm.
#It reads standard input (usually gvpin),
#and sends it to the pinlabel output window OUTPUT_WINDOW,
#e.g. gvim.  It is sent using xse.
#The environment variables OUTPUT_WINDOW and XSE
#used here are defined in pin.sh.
#vim syntax may parse this file incorrectly.

#written originally in February, 2009
#last modified July, 2009

shopt -u nocasematch #just to be safe

if test ! "$OUTPUT_WINDOW"; then
    echo "Click on the output window."
    echo "(e.g. gvim or gnome-terminal.  An xterm window may fail.)"
    OUTPUT_WINDOW=`xwininfo | awk 'NR==6 {print $4}'`
    echo "Window ${OUTPUT_WINDOW} selected."
fi

tmpfile="/tmp/keytowindow.$$"
\rm -f "$tmpfile"
touch "$tmpfile"

trap '\rm -f $tmpfile; exit 1' 1 2 15

line="$@"
n=0
#next loop parses characters and sends them to tmpfile
while [ "$n" -lt "${#line}" ] 
do
    char="${line:n:1}"
    n=$(( $n + 1 ))
    case "$char" in
	'`')
	    output='<Key>grave';;
	'~')
	    output='Shift<Key>asciitilde';;
	'!')
	    output='Shift<Key>exclam';;
	'@')
	    output='Shift<Key>at';;
	'#')
	    output='Shift<Key>numbersign';;
	'$')
	    output='Shift<Key>dollar';;
	'%')
	    output='Shift<Key>percent';;
	'^')
	    output='Shift<Key>asciicircum';;
	'&')
	    output='Shift<Key>ampersand';;
	'*')
	    output='Shift<Key>asterisk';;
	'(')
	    output='Shift<Key>parenleft';;
	')')
	    output='Shift<Key>parenright';;
	'-')
	    output='<Key>minus';;
	'_')
	    output='Shift<Key>underscore';;
	'=')
	    output='<Key>equal';;
	'+')
	    output='Shift<Key>plus';;
	'[')
	    output='<Key>bracketleft';;
	']')
	    output='<Key>bracketright';;
	'{')
	    output='Shift<Key>braceleft';;
	'}')
	    output='Shift<Key>braceright';;
	'|')
	    output='Shift<Key>bar';;
#	    '\')
#		output='<Key>backslash';;
	' ')
	    output='<Key>space';;
	';')
	    output='<Key>semicolon';;
	':')
	    output='Shift<Key>colon';;
	"'")
	    output='<Key>apostrophe';;
	'"')
	    output='Shift<Key>quotedbl';;
	'?')
	    output='Shift<Key>question';;
	'/')
	    output='<Key>slash';;
	'>')
	    output='Shift<Key>greater';;
	'<')
	    output='Shift<Key>less';;
	'.')
	    output='<Key>period';;
	',')
	    output='<Key>comma';;
	'A'|'B'|'C'|'D'|'E'|'F'|'G'|'H'|'I'|'J'|'K'|'L'|'M'|'N'|'O'|'P'|'Q'|'R'|'S'|'T'|'U'|'V'|'W'|'X'|'Y'|'Z')#just to be safe
	    output="Shift<Key>${char}";;
	'\')
	    next_char="${line:n:1}"
	    n=$(( $n + 1 ))
	    case "$next_char" in
		"n")
		    output="<Key>Return";;
		"t")
		    output="<Key>Tab";;
		"e")
		    output="<Key>Escape";;
		*)
		    output="<Key>backslash"
		    n=$(( $n - 1 ));;
	    esac;;
	*) #assume lower case letter
	    output="<Key>${char}";;
    esac	
    echo "$output" >>"$tmpfile"
done
#send contents of tmpfile to xse
"${XSE:=xse}" -window "$OUTPUT_WINDOW" -file "$tmpfile"

\rm -f "$tmpfile"
